Index: /branches/multichoice/gui/scripts/vtkvolumeviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/vtkvolumeviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/vtkvolumeviewer.tcl	(revision 6371)
@@ -74,5 +74,4 @@
     private method BuildVolumeComponents {}
     private method BuildVolumeTab {}
-    private method Combo { option }
     private method ComputeAlphamap { cname }
     private method ComputeTransferFunction { cname }
@@ -97,4 +96,5 @@
     private method IsValidObject { dataobj }
     private method LeaveLegend {}
+    private method LegendTitleAction { option }
     private method MotionLegend { x y }
     private method Pan {option x y}
@@ -109,5 +109,5 @@
     private method ReceiveDataset { args }
     private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title vmin vmax size }
+    private method ReceiveLegend { colormap title min max size }
     private method RemoveMarker { x y }
     private method RequestLegend {}
@@ -115,4 +115,5 @@
     private method Rotate {option x y}
     private method SendTransferFunctions {}
+    private method SetCurrentFieldName { dataobj }
     private method SetInitialTransferFunction { dataobj cname }
     private method SetLegendTip { x y }
@@ -240,7 +241,7 @@
     array set _settings {
         -axesvisible            1
-        -axisflymode            static
         -axislabels             1
         -axisminorticks         1
+        -axismode               "static"
         -background             black
         -color                  "default"
@@ -536,7 +537,4 @@
     }
     array set params $settings
-    set params(-description) ""
-    set params(-param) ""
-    array set params $settings
 
     if {$params(-color) == "auto" || $params(-color) == "autoreset"} {
@@ -577,5 +575,4 @@
         set _dlist [lreplace $_dlist $pos $pos]
         array unset _obj2ovride $dataobj-*
-        array unset _settings $dataobj-*
         set changed 1
     }
@@ -638,5 +635,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view\""
@@ -652,5 +649,5 @@
         }
         default {
-            error "bad option \"$op\": should be -objects or -image"
+            error "bad option \"$op\": should be -objects, -visible or -image"
         }
     }
@@ -1004,5 +1001,5 @@
         set _first ""
         InitSettings -background \
-            -xgrid -ygrid -zgrid -axisflymode \
+            -xgrid -ygrid -zgrid -axismode \
             -axesvisible -axislabels -axisminorticks
         StopBufferingCommands
@@ -1020,4 +1017,5 @@
         if { [info exists _obj2ovride($dataobj-raise)] &&  $_first == "" } {
             set _first $dataobj
+            SetCurrentFieldName $dataobj
         }
         foreach cname [$dataobj components] {
@@ -1066,34 +1064,4 @@
             }
         }
-        $itk_component(field) choices delete 0 end
-        $itk_component(fieldmenu) delete 0 end
-        array unset _fields
-        set _curFldName ""
-        foreach cname [$_first components] {
-            foreach fname [$_first fieldnames $cname] {
-                if { [info exists _fields($fname)] } {
-                    continue
-                }
-                foreach { label units components } \
-                    [$_first fieldinfo $fname] break
-                # Only scalar fields are valid
-                if {$_allowMultiComponent || $components == 1} {
-                    $itk_component(field) choices insert end "$fname" "$label"
-                    $itk_component(fieldmenu) add radiobutton -label "$label" \
-                        -value $label -variable [itcl::scope _curFldLabel] \
-                        -selectcolor red \
-                        -activebackground $itk_option(-plotbackground) \
-                        -activeforeground $itk_option(-plotforeground) \
-                        -font "Arial 8" \
-                        -command [itcl::code $this Combo invoke]
-                    set _fields($fname) [list $label $units $components]
-                    if { $_curFldName == "" } {
-                        set _curFldName $fname
-                        set _curFldLabel $label
-                    }
-                }
-            }
-        }
-        $itk_component(field) value $_curFldLabel
     }
 
@@ -1331,8 +1299,4 @@
 itcl::body Rappture::VtkVolumeViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
-            # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
-        }
         AdjustSetting $spec
     }
@@ -1351,7 +1315,21 @@
     }
     switch -- $what {
-        "-current" {
-            set cname [$itk_component(volcomponents) value]
-            SwitchComponent $cname
+        "-axesvisible" {
+            set bool $_settings($what)
+            SendCmd "axis visible all $bool"
+        }
+        "-axislabels" {
+            set bool $_settings($what)
+            SendCmd "axis labels all $bool"
+        }
+        "-axisminorticks" {
+            set bool $_settings($what)
+            SendCmd "axis minticks all $bool"
+        }
+        "-axismode" {
+            set mode [$itk_component(axismode) value]
+            set mode [$itk_component(axismode) translate $mode]
+            set _settings($what) $mode
+            SendCmd "axis flymode $mode"
         }
         "-background" {
@@ -1368,135 +1346,13 @@
             DrawLegend
         }
-        "-volumeoutline" {
-            set bool $_settings($what)
-            SendCmd "outline visible 0"
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "outline visible $bool $tag"
-            }
-        }
-        "-legendvisible" {
-            set bool $_settings($what)
-            if { $bool } {
-                blt::table $itk_component(plotarea) \
-                    1,0 $itk_component(legend) -fill x
-            } else {
-                blt::table forget $itk_component(legend)
-            }
-        }
-        "-volumevisible" {
-            set bool $_settings($what)
-            set _settings($_current${what}) $bool
-            # Only the data objects in the array _obj2ovride(*-raise) are
-            # in the working set and can be displayed on screen. The global
-            # volume control determines whether they are visible.
-            #
-            # Note: The use of the current component is a hold over from
-            #       nanovis.  If we can't display more than one volume,
-            #       we don't have to limit the effects to a specific
-            #       component.
-            foreach tag [GetDatasetsWithComponent $_current] {
-                foreach {dataobj cname} [split $tag -] break
-                if { [info exists _obj2ovride($dataobj-raise)] } {
-                    SendCmd "volume visible $bool $tag"
-                }
-            }
-            if { $bool } {
-                Rappture::Tooltip::for $itk_component(volume) \
-                    "Hide the volume"
-            } else {
-                Rappture::Tooltip::for $itk_component(volume) \
-                    "Show the volume"
-            }
-        }
-        "-volumeblendmode" {
-            set val [$itk_component(blendmode) value]
-            set mode [$itk_component(blendmode) translate $val]
-            set _settings($what) $mode
-            set _settings($_current${what}) $mode
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume blendmode $mode $tag"
-            }
-        }
-        "-volumeambient" {
-            # Other parts of the code use the -volumeambient setting to
-            # tell if the component settings have been initialized
-            if { ![info exists _settings($_current${what})] } {
-                InitComponentSettings $_current
-            }
-            set val $_settings($what)
-            set _settings($_current${what}) $val
-            set ambient [expr {0.01*$val}]
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume shading ambient $ambient $tag"
-            }
-        }
-        "-volumediffuse" {
-            set val $_settings($what)
-            set _settings($_current${what}) $val
-            set diffuse [expr {0.01*$val}]
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume shading diffuse $diffuse $tag"
-            }
-        }
-        "-volumespecularlevel" - "-volumespecularexponent" {
-            set val $_settings($what)
-            set _settings($_current${what}) $val
-            set level [expr {0.01*$val}]
-            set exp $_settings($what)
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume shading specular $level $exp $tag"
-            }
-        }
-        "-volumelighting" {
-            set bool $_settings($what)
-            set _settings($_current${what}) $bool
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume lighting $bool $tag"
-            }
-        }
-        "-volumeopacity" {
-            set val $_settings($what)
-            set _settings($_current${what}) $val
-            set val [expr {0.01*$val}]
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume opacity $val $tag"
-            }
-        }
-        "-volumequality" {
-            set val $_settings($what)
-            set _settings($_current${what}) $val
-            set val [expr {0.01*$val}]
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume quality $val $tag"
-            }
-        }
-        "-axesvisible" {
-            set bool $_settings($what)
-            SendCmd "axis visible all $bool"
-        }
-        "-axislabels" {
-            set bool $_settings($what)
-            SendCmd "axis labels all $bool"
-        }
-        "-axisminorticks" {
-            set bool $_settings($what)
-            SendCmd "axis minticks all $bool"
-        }
-        "-xgrid" - "-ygrid" - "-zgrid" {
-            set axis [string range $what 1 1]
-            set bool $_settings($what)
-            SendCmd "axis grid $axis $bool"
-        }
-        "-axisflymode" {
-            set mode [$itk_component(axismode) value]
-            set mode [$itk_component(axismode) translate $mode]
-            set _settings($what) $mode
-            SendCmd "axis flymode $mode"
-        }
-        "-cutplanesvisible" {
-            set bool $_settings($what)
-            foreach dataset [CurrentDatasets -visible] {
-                SendCmd "$_cutplaneCmd visible $bool $dataset"
-            }
+        "-color" {
+            set color [$itk_component(colormap) value]
+            set _settings($what) $color
+            set _settings($_current${what}) $color
+            ResetColormap $_current $color
+        }
+        "-current" {
+            set cname [$itk_component(volcomponents) value]
+            SwitchComponent $cname
         }
         "-cutplanelighting" {
@@ -1524,35 +1380,9 @@
             }
         }
-        "-xcutplanevisible" - "-ycutplanevisible" - "-zcutplanevisible" {
-            set axis [string range $what 1 1]
+        "-cutplanesvisible" {
             set bool $_settings($what)
-            if { $bool } {
-                $itk_component(${axis}CutScale) configure -state normal \
-                    -troughcolor white
-            } else {
-                $itk_component(${axis}CutScale) configure -state disabled \
-                    -troughcolor grey82
-            }
             foreach dataset [CurrentDatasets -visible] {
-                SendCmd "$_cutplaneCmd axis $axis $bool $dataset"
-            }
-        }
-        "-xcutplaneposition" - "-ycutplaneposition" - "-zcutplaneposition" {
-            set axis [string range $what 1 1]
-            set pos [expr $_settings($what) * 0.01]
-            foreach dataset [CurrentDatasets -visible] {
-                SendCmd "$_cutplaneCmd slice ${axis} ${pos} $dataset"
-            }
-            set _cutplanePending 0
-        }
-        "-volumethickness" {
-            set _settings($_current${what}) $_settings($what)
-            updateTransferFunctions
-        }
-        "-color" {
-            set color [$itk_component(colormap) value]
-            set _settings($what) $color
-            set _settings($_current${what}) $color
-            ResetColormap $_current $color
+                SendCmd "$_cutplaneCmd visible $bool $dataset"
+            }
         }
         "-field" {
@@ -1584,4 +1414,138 @@
             SendCmd "camera reset"
             DrawLegend
+        }
+        "-legendvisible" {
+            set bool $_settings($what)
+            if { $bool } {
+                blt::table $itk_component(plotarea) \
+                    1,0 $itk_component(legend) -fill x
+            } else {
+                blt::table forget $itk_component(legend)
+            }
+        }
+        "-volumeambient" {
+            # Other parts of the code use the -volumeambient setting to
+            # tell if the component settings have been initialized
+            if { ![info exists _settings($_current${what})] } {
+                InitComponentSettings $_current
+            }
+            set val $_settings($what)
+            set _settings($_current${what}) $val
+            set ambient [expr {0.01*$val}]
+            foreach tag [GetDatasetsWithComponent $_current] {
+                SendCmd "volume shading ambient $ambient $tag"
+            }
+        }
+        "-volumeblendmode" {
+            set val [$itk_component(blendmode) value]
+            set mode [$itk_component(blendmode) translate $val]
+            set _settings($what) $mode
+            set _settings($_current${what}) $mode
+            foreach tag [GetDatasetsWithComponent $_current] {
+                SendCmd "volume blendmode $mode $tag"
+            }
+        }
+        "-volumediffuse" {
+            set val $_settings($what)
+            set _settings($_current${what}) $val
+            set diffuse [expr {0.01*$val}]
+            foreach tag [GetDatasetsWithComponent $_current] {
+                SendCmd "volume shading diffuse $diffuse $tag"
+            }
+        }
+        "-volumelighting" {
+            set bool $_settings($what)
+            set _settings($_current${what}) $bool
+            foreach tag [GetDatasetsWithComponent $_current] {
+                SendCmd "volume lighting $bool $tag"
+            }
+        }
+        "-volumeopacity" {
+            set val $_settings($what)
+            set _settings($_current${what}) $val
+            set val [expr {0.01*$val}]
+            foreach tag [GetDatasetsWithComponent $_current] {
+                SendCmd "volume opacity $val $tag"
+            }
+        }
+        "-volumeoutline" {
+            set bool $_settings($what)
+            SendCmd "outline visible 0"
+            foreach tag [GetDatasetsWithComponent $_current] {
+                SendCmd "outline visible $bool $tag"
+            }
+        }
+        "-volumequality" {
+            set val $_settings($what)
+            set _settings($_current${what}) $val
+            set val [expr {0.01*$val}]
+            foreach tag [GetDatasetsWithComponent $_current] {
+                SendCmd "volume quality $val $tag"
+            }
+        }
+        "-volumespecularlevel" - "-volumespecularexponent" {
+            set val $_settings($what)
+            set _settings($_current${what}) $val
+            set level [expr {0.01*$val}]
+            set exp $_settings($what)
+            foreach tag [GetDatasetsWithComponent $_current] {
+                SendCmd "volume shading specular $level $exp $tag"
+            }
+        }
+        "-volumethickness" {
+            set _settings($_current${what}) $_settings($what)
+            updateTransferFunctions
+        }
+        "-volumevisible" {
+            set bool $_settings($what)
+            set _settings($_current${what}) $bool
+            # Only the data objects in the array _obj2ovride(*-raise) are
+            # in the working set and can be displayed on screen. The global
+            # volume control determines whether they are visible.
+            #
+            # Note: The use of the current component is a hold over from
+            #       nanovis.  If we can't display more than one volume,
+            #       we don't have to limit the effects to a specific
+            #       component.
+            foreach tag [GetDatasetsWithComponent $_current] {
+                foreach {dataobj cname} [split $tag -] break
+                if { [info exists _obj2ovride($dataobj-raise)] } {
+                    SendCmd "volume visible $bool $tag"
+                }
+            }
+            if { $bool } {
+                Rappture::Tooltip::for $itk_component(volume) \
+                    "Hide the volume"
+            } else {
+                Rappture::Tooltip::for $itk_component(volume) \
+                    "Show the volume"
+            }
+        }
+        "-xcutplanevisible" - "-ycutplanevisible" - "-zcutplanevisible" {
+            set axis [string range $what 1 1]
+            set bool $_settings($what)
+            if { $bool } {
+                $itk_component(${axis}CutScale) configure -state normal \
+                    -troughcolor white
+            } else {
+                $itk_component(${axis}CutScale) configure -state disabled \
+                    -troughcolor grey82
+            }
+            foreach dataset [CurrentDatasets -visible] {
+                SendCmd "$_cutplaneCmd axis $axis $bool $dataset"
+            }
+        }
+        "-xcutplaneposition" - "-ycutplaneposition" - "-zcutplaneposition" {
+            set axis [string range $what 1 1]
+            set pos [expr $_settings($what) * 0.01]
+            foreach dataset [CurrentDatasets -visible] {
+                SendCmd "$_cutplaneCmd slice ${axis} ${pos} $dataset"
+            }
+            set _cutplanePending 0
+        }
+        "-xgrid" - "-ygrid" - "-zgrid" {
+            set axis [string range $what 1 1]
+            set bool $_settings($what)
+            SendCmd "axis grid $axis $bool"
         }
         default {
@@ -1908,6 +1872,6 @@
         "furthest_triad"  "farthest" \
         "outer_edges"     "outer"
-    $itk_component(axismode) value $_settings(-axisflymode)
-    bind $inner.mode <<Value>> [itcl::code $this AdjustSetting -axisflymode]
+    $itk_component(axismode) value $_settings(-axismode)
+    bind $inner.mode <<Value>> [itcl::code $this AdjustSetting -axismode]
 
     blt::table $inner \
@@ -2174,5 +2138,5 @@
     radiobutton $inner.vtk_button -text "VTK data file" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Helvetica 9 " \
+        -font "Arial 9" \
         -value vtk
     Rappture::Tooltip::for $inner.vtk_button "Save as VTK data file."
@@ -2252,5 +2216,5 @@
 
 # ----------------------------------------------------------------------
-# USAGE: ReceiveLegend <colormap> <title> <vmin> <vmax> <size>
+# USAGE: ReceiveLegend <colormap> <title> <min> <max> <size>
 #
 # Invoked automatically whenever the "legend" command comes in from
@@ -2258,5 +2222,5 @@
 # specified <size> will follow.
 # ----------------------------------------------------------------------
-itcl::body Rappture::VtkVolumeViewer::ReceiveLegend { colormap title vmin vmax size } {
+itcl::body Rappture::VtkVolumeViewer::ReceiveLegend { colormap title min max size } {
     if { [isconnected] } {
         set bytes [ReceiveBytes $size]
@@ -2428,15 +2392,17 @@
 
 # ----------------------------------------------------------------------
-# USAGE: _dropdown post
-# USAGE: _dropdown unpost
-# USAGE: _dropdown select
-#
-# Used internally to handle the dropdown list for this combobox.  The
-# post/unpost options are invoked when the list is posted or unposted
-# to manage the relief of the controlling button.  The select option
-# is invoked whenever there is a selection from the list, to assign
-# the value back to the gauge.
-# ----------------------------------------------------------------------
-itcl::body Rappture::VtkVolumeViewer::Combo {option} {
+# USAGE: LegendTitleAction post
+# USAGE: LegendTitleAction enter
+# USAGE: LegendTitleAction leave
+# USAGE: LegendTitleAction save
+#
+# Used internally to handle the dropdown list for the fields menu combobox.
+# The post option is invoked when the field title is pressed to launch the
+# dropdown.  The enter option is invoked when the user mouses over the field
+# title. The leave option is invoked when the user moves the mouse away
+# from the field title.  The save option is invoked whenever there is a
+# selection from the list, to alert the visualization server.
+# ----------------------------------------------------------------------
+itcl::body Rappture::VtkVolumeViewer::LegendTitleAction {option} {
     set c $itk_component(view)
     switch -- $option {
@@ -2448,16 +2414,16 @@
             tk_popup $itk_component(fieldmenu) $x $y
         }
-        activate {
+        enter {
             $c itemconfigure title -fill red
         }
-        deactivate {
+        leave {
             $c itemconfigure title -fill $itk_option(-plotforeground)
         }
-        invoke {
+        save {
             $itk_component(field) value $_curFldLabel
             AdjustSetting -field
         }
         default {
-            error "bad option \"$option\": should be post, unpost, select"
+            error "bad option \"$option\": should be post, enter, leave or save"
         }
     }
@@ -2510,5 +2476,5 @@
         } else {
             # $n : absolute value, compute relative
-            lappend list  [expr {(double($value)-$min)/($max-$min)]}
+            lappend list [expr {(double($value)-$min)/($max-$min)}]
         }
     }
@@ -2865,2 +2831,36 @@
     return [ColorsToColormap $color]
 }
+
+itcl::body Rappture::VtkVolumeViewer::SetCurrentFieldName { dataobj } {
+    set _first $dataobj
+    $itk_component(field) choices delete 0 end
+    $itk_component(fieldmenu) delete 0 end
+    array unset _fields
+    set _curFldName ""
+    foreach cname [$_first components] {
+        foreach fname [$_first fieldnames $cname] {
+            if { [info exists _fields($fname)] } {
+                continue
+            }
+            foreach { label units components } \
+                [$_first fieldinfo $fname] break
+            # Only scalar fields are valid
+            if {$_allowMultiComponent || $components == 1} {
+                $itk_component(field) choices insert end "$fname" "$label"
+                $itk_component(fieldmenu) add radiobutton -label "$label" \
+                    -value $label -variable [itcl::scope _curFldLabel] \
+                    -selectcolor red \
+                    -activebackground $itk_option(-plotbackground) \
+                    -activeforeground $itk_option(-plotforeground) \
+                    -font "Arial 8" \
+                    -command [itcl::code $this LegendTitleAction save]
+                set _fields($fname) [list $label $units $components]
+                if { $_curFldName == "" } {
+                    set _curFldName $fname
+                    set _curFldLabel $label
+                }
+            }
+        }
+    }
+    $itk_component(field) value $_curFldLabel
+}
Index: /branches/multichoice/lang/tcl/scripts/library.tcl
===================================================================
--- /branches/multichoice/lang/tcl/scripts/library.tcl	(revision 6370)
+++ /branches/multichoice/lang/tcl/scripts/library.tcl	(revision 6371)
@@ -75,4 +75,5 @@
             close $fid
         } errs] != 0 } {
+            global errorInfo
             puts stderr "can't open \"$fname\": errs=$errs errorInfo=$errorInfo"
         }
@@ -90,4 +91,5 @@
             close $fid
         } errs] != 0 } {
+            global errorInfo
             puts stderr "can't open \"$fname\": errs=$errs errorInfo=$errorInfo"
         }
@@ -1067,6 +1069,6 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::LibraryObj::uq_get_vars {{tfile ""}} {
-    set varout \[
-    set varlist []
+    set varout "\["
+    set varlist {}
 
     if {$tfile == ""} {
Index: /branches/multichoice/lang/tcl/scripts/task.tcl
===================================================================
--- /branches/multichoice/lang/tcl/scripts/task.tcl	(revision 6370)
+++ /branches/multichoice/lang/tcl/scripts/task.tcl	(revision 6371)
@@ -218,5 +218,6 @@
 
     # write out the driver.xml file for the tool
-    set file "driver[pid].xml"
+    global rapptureInfo
+    set file [file join $rapptureInfo(cwd) "driver[pid].xml"]
     set status [catch {
         set fid [open $file w]
@@ -578,5 +579,6 @@
                 set rdir $_resources(-resultdir)
             } else {
-                set rdir "."
+                global rapptureInfo
+                set rdir $rapptureInfo(cwd)
             }
         } elseif {$resultdir ne ""} {
Index: /branches/multichoice/puq/puq.sh.in
===================================================================
--- /branches/multichoice/puq/puq.sh.in	(revision 6370)
+++ /branches/multichoice/puq/puq.sh.in	(revision 6371)
@@ -21,4 +21,4 @@
 script=$1
 shift
-exec ${python} ${puq_exec_prefix}/${script}.py $*
+exec ${python} ${puq_exec_prefix}/${script}.py "$@"
 
Index: /branches/multichoice/tester/scripts/main.tcl
===================================================================
--- /branches/multichoice/tester/scripts/main.tcl	(revision 6370)
+++ /branches/multichoice/tester/scripts/main.tcl	(revision 6371)
@@ -148,5 +148,5 @@
 wm title . "Rappture Regression Tester"
 wm geometry . 800x500
-Rappture::Panes .pw -orientation horizontal -sashcursor sb_h_double_arrow
+Rappture::Panes .pw -orientation horizontal
 pack .pw -expand yes -fill both
 
@@ -262,5 +262,5 @@
 
 # viewer for value diffs where we have a special object viewer
-Rappture::Panes .testdiffs.body.val2objs -orientation horizontal -sashcursor sb_h_double_arrow
+Rappture::Panes .testdiffs.body.val2objs -orientation horizontal
 
 # empty area for the object value viewer
